------------------------------------------
--Set up Preferences file
------------------------------------------
--create preferences xml
options = renoise.Document.create {
  preserve_column_pos = false
}

 --assign options-object to .preferences so renoise knows to load and update it with the tool
renoise.tool().preferences = options
------------------------------------------
------------------------------------------

--dialog global
local my_dialog


--------------------------------------------------------------
--GUI
--------------------------------------------------------------
function invoke_gui()
  
  --1 dialog at a time
  if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
    my_dialog:close()
    return
  end

  --viewbuilder object
  local vb = renoise.ViewBuilder()
  
  ---------------------------------------
  --executes when re-order button pressed
  ----------------------------------------
  local function re_order_button()
    if vb.views["popup"].value == 1 then
      process_single_track_in_pattern() 
    elseif vb.views["popup"].value  == 2 then  
     -- process_selection_in_pattern()
     main_selection_in_pattern()
    elseif vb.views["popup"].value  == 3 then
      process_whole_track()
    end 
  end
  
  --dialog content
  local dialog_content = vb:column {
   
      margin = 4,
      
      vb:vertical_aligner {
       mode = "center",
       spacing = 8,
      
      vb:column {
       style = "group",
       margin = 7,
       
      vb:text {
       text = "Range:" 
      },
      
      vb:popup {
       value = 1,
       id = "popup",
       width = 120,
       items = {
         "Track in Pattern",
         "Selection in Track",
         "Track in Song",
        },           
       }, 
       
       vb:text {
       text = "Left Align:" 
      },
      
      vb:checkbox{
      value = not options.preserve_column_pos.value, --`not` preserve columns as GUI label is left align
      notifier = function()options.preserve_column_pos.value = not options.preserve_column_pos.value
                 end
      },
       
       
      },--column
      
      vb:horizontal_aligner {
       mode = "center",
       margin = 4,
      
      vb:button {
       text = "Re-Order",
       id = "button",
       height = 24,
       width = 110,
       notifier = function()  
                    re_order_button()
                  end,
      },           
     }
    }
   }
  ------------------------------------------------------      
   --key Handler
  local function my_keyhandler_func(dialog, key)
  
   --scrolling the range popup with the up and down keys
 --[[  if key.name == "down" then
     if vb.views["popup"].value < 3 then
       vb.views["popup"].value = vb.views["popup"].value + 1
     else 
       return
     end
   elseif key.name == "up" then
     if vb.views["popup"].value > 1 then
       vb.views["popup"].value = vb.views["popup"].value - 1
     else
       return
     end 
     
   --executing re-order button with return key
   elseif key.name == "return" then
     re_order_button()--]]
     
   --closing the dialog with escape
   if not (key.modifiers == "" and key.name == "esc") then
      return key
   else
     dialog:close()
   end
  end
  
  my_dialog = renoise.app():show_custom_dialog("Re-Order Notes", dialog_content, my_keyhandler_func)
end
