

--slow on whole track so needs process slicer
require "process_slicer"   
require "GUI" 

--keybinding
 renoise.tool():add_keybinding {
  name = "Global:Tools:Reorder Notes By Pitch",
  invoke = function() invoke_gui() end
}

--menu
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:Reorder Notes By Pitch",
  invoke = function() invoke_gui() end
}


--bool- defined in following process functions
local single_track 

--Process slicers Current track or all tracks
-----------------------------------------------------------------------
--Current track
function process_single_track_in_pattern()
  single_track = true
  local slicer = ProcessSlicer(main)
  slicer:start()
end
-----------------------------------------------------------------------
--All tracks
function process_whole_track()
  single_track = false
  local slicer = ProcessSlicer(main)
  slicer:start()
end

--selection in pattern
function process_selection_in_pattern()
  local slicer = ProcessSlicer(main_selection_in_pattern)
  slicer:start()
end

-----------------------------------------------------------------------
--[[--Whole Song
function process_whole_song()
  local slicer = ProcessSlicer(main_whole_song)
  slicer:start()
end--]]

-----------------------------------------------------------------------
-----------------------------
--bubble sort
----------------------------- 
function modded_bubbleSort_left_align(t)
  
  --[i] is the column number
  --[i][1] is the note value for that column
  for i = 1, #t do
    for i2 = 1, #t do
      if t[i][1] < t[i2][1] then
        t[i],t[i2] = t[i2], t[i]
      end
    end
  end
end

-----------------------------
--Constants to filter in sort
local NOTE_OFF = 120
local EMPTY_NOTE = 121

-----------------------------
--bubble sort
----------------------------- 
function modded_bubbleSort(t)
  
  --[i] is the column number
  --[i][1] is the note value for that column
  for i = 1, #t do
    if t[i][1] < NOTE_OFF then --filter note_offs and empty_lines for i (only notes are compared and swapped)
      for i2 = 1, #t do
        if t[i2][1] < NOTE_OFF then --filter note_offs and empty_lines for i2 (only notes are compared and swapped)  
          if t[i][1] < t[i2][1] then
            t[i],t[i2] = t[i2], t[i]
          end
        end
      end
    end
  end
end
  
---------------------
--main
---------------------
function main()

  local song = renoise.song()
  
  local start_pattern
  local end_pattern
  
  if single_track then
    start_pattern = song.selected_pattern_index
    end_pattern = song.selected_pattern_index
  else
    start_pattern = 1
    end_pattern = #song.patterns
  end
 
  --song values  

  local pattern_iter = song.pattern_iterator
  local pattern_index = song.selected_pattern_index
  local track_index = song.selected_track_index
  --table and incrementors
  local pattern_notes = {}
  local selected_line = 1
  local current_line = 1
 
  --iterate
  for i = start_pattern,end_pattern do --only current pattern as too slow
   
    if (i % 3) == 0 then --only relevant for multiple patterns
      coroutine.yield()
    end 
    --reset counters for each pattern
    selected_line = 1
    current_line = 1
    --status
    if start_pattern == end_pattern then
      renoise.app():show_status("Re-Order Notes By Pitch Tool: (Re-Ordering `"..song.selected_track.name.."` Current Pattern: "..(i-1)..")")  
    else  
      renoise.app():show_status("Re-Order Notes By Pitch Tool: (Re-Ordering `"..song.selected_track.name.."` Pattern: "..(i-1).." / "..(end_pattern-1).."`)")   
    end
    --iterate track in pattern
    for pos,line in pattern_iter:note_columns_in_pattern_track(i,track_index) do
  
       pattern_notes[current_line] = { line.note_value, line.instrument_value, line.volume_value, line.panning_value, line.delay_value }
       current_line = current_line + 1
      --end of row
      if current_line == 13 then 
  
        --sort
        if not options.preserve_column_pos.value == true then
          modded_bubbleSort_left_align(pattern_notes)
        else
          modded_bubbleSort(pattern_notes)
        end
        --add in values
        local line = song.patterns[i].tracks[track_index].lines[selected_line]
      
        for i = 1,12 do
          line.note_columns[i]:clear()--clear current line
          line.note_columns[i].note_value = pattern_notes[i][1]--add sorted notes:
          line.note_columns[i].instrument_value = pattern_notes[i][2]
          line.note_columns[i].volume_value = pattern_notes[i][3]
          line.note_columns[i].panning_value = pattern_notes[i][4]
          line.note_columns[i].delay_value = pattern_notes[i][5] 
        end 
        --increment
        selected_line = selected_line + 1
        current_line = 1    
      end   
    end 
  end
  
  
  renoise.app():show_status("Re-Order Notes By Pitch Tool: (Re-Order Complete)")
end

-----------------------------------
--selection in pattern
-----------------------------------
function main_selection_in_pattern()


  --status
  renoise.app():show_status("Re-Order Notes By Pitch Tool: (Re-Ordering Selection In Current Pattern Track)") 

  local song = renoise.song()
  
  --song values  
  local pattern_iter = song.pattern_iterator
  local pattern_index = song.selected_pattern_index
  local track_index = song.selected_track_index
  --table and incrementors
  local pattern_notes = {}
  local selected_line = 1



  --table to hold the values for selection edges in the current pattern_track
  ---------------------------------------------------------------------------
  local selection = {left_selected_column = nil,
                     right_selected_column = nil,
                     first_selected_line = nil,
                     last_selected_line = nil}
 
  --get selection for current track and fill in the selection table
  for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
    --table pos has the fields {column,line,pattern,track}

    if line.is_selected then
      --if the first selected column field is nil then write the first encountered selected value to it
      if (selection.left_selected_column == nil) then
        selection.left_selected_column = pos.column
      end
      --keep overwriting the last column so that the laste selected column will be left 
      if (selection.right_selected_column == nil) or selection.right_selected_column < pos.column then
        selection.right_selected_column = pos.column
      end
      --similar for lines
      if selection.first_selected_line == nil then
        selection.first_selected_line = pos.line
      end
      --keep overwriting the last column so that the laste selected column will be left 
      if (selection.last_selected_line == nil) or selection.last_selected_line < pos.line then
        selection.last_selected_line = pos.line
      end
    end
  end
  ------------------------------------------------------------------------------

  if selection.first_selected_line == nil then
    renoise.app():show_status("Re-Order Notes By Pitch Tool: (No Selection Has Been Made In The Current Pattern Track)")
    return
  end
  
  local pattern_track = renoise.song().patterns[pattern_index].tracks[track_index]
  local current_line = 1
  
  --loop through the columns and create a table for the bubble sort, row by row
  for i = selection.first_selected_line, selection.last_selected_line do
    
    --dynamic status
    renoise.app():show_status("Re-Order Notes By Pitch Tool: (Re-Ordering Progress "..i.." / "..selection.last_selected_line.." )") 
    
    --reset incrementor for each new row
    current_line = 1
    -----------------------------------------------------------------------------------
    --get note values with loop and fill table pattern notes (current row in each pass)
    -----------------------------------------------------------------------------------
    
    for column = selection.left_selected_column, selection.right_selected_column do
      --get each line
      local line = pattern_track.lines[i].note_columns[column]
      --add values into pattern notes table
      pattern_notes[current_line] = { line.note_value, line.instrument_value, line.volume_value, line.panning_value, line.delay_value }
      --increment
      current_line = current_line + 1
    end
    
    -------------------------------------------
    --sort pattern notes_table with bubble sort
    -------------------------------------------
    
    if not options.preserve_column_pos.value == true then
      modded_bubbleSort_left_align(pattern_notes)
    else
      modded_bubbleSort(pattern_notes)
    end
    
    ---------------------------------------------------
    --write re-ordered notes, back to pattern with loop
    ---------------------------------------------------
    
     local inc = 1
     for column = selection.left_selected_column, selection.right_selected_column do
       
       --get each line
       local line = pattern_track.lines[i].note_columns[column]
       --loop to re -add sorted notes
        line:clear()--clear current line
        line.note_value = pattern_notes[inc][1]--add sorted notes:
        line.instrument_value = pattern_notes[inc][2]
        line.volume_value = pattern_notes[inc][3]
        line.panning_value = pattern_notes[inc][4]
        line.delay_value = pattern_notes[inc][5] 
        
        --increment
        inc = inc + 1
     end 
  end
  renoise.app():show_status("Re-Order Notes By Pitch Tool: (Re-Order Complete)")--]]
end


